﻿using CitizenFX.Core;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TheLastPlanet.Server.gmPrincipale;
using TheLastPlanet.Shared.TelefonoShared;

namespace TheLastPlanet.Server.Telefono.ClientData
{
	public class Phone : BaseScript
	{
		dynamic data;
		public List<Phone_data> phone_data = new List<Phone_data>();
		public Phone() { }
		[JsonIgnore]
		public Player p;
		public Phone(Player player, dynamic result)
		{
			p = player;
			data = JsonConvert.DeserializeObject(result.phone_data);
			for (int i = 0; i < data.Count; i++)
				phone_data.Add(new Phone_data(data[i]));
		}

		public Phone_data getCurrentCharPhone()
		{
			for (int i = 0; i < phone_data.Count; i++)
			{
				if ((ServerScript.PlayerList[p.Handle].char_current - 1) == phone_data[i].id - 1)
					return phone_data[i];
			}
			return null;
		}
	}

	public class Phone_data
	{
		public int id { get; set; } = 1;
		public int Theme { get; set; } = 1;
		public int Wallpaper { get; set; } = 4;
		public int Ringtone { get; set; } = 0;
		public int SleepMode { get; set; } = 0;
		public int Vibration { get; set; } = 1;
		public string Numero { get; private set; } = "0";

		public List<Contatto> contatti = new List<Contatto>()
		{
			new Contatto("Aggiungi Contatto", "CHAR_MULTIPLAYER", false, "", 0),
			new Contatto("Polizia", "CHAR_CALL911", false, "polizia", 0),
			new Contatto("Medico", "CHAR_CALL911", false, "medici", 0),
			new Contatto("Meccanico", "CHAR_LS_CUSTOMS", false, "meccanico", 0),
			new Contatto("Taxi", "CHAR_TAXI", false, "taxi", 0),
			new Contatto("Concessionario", "CHAR_CARSITE2", false, "concessionario", 0),
			new Contatto("Agente Immobiliare", "CHAR_PEGASUS_DELIVERY", false, "immobiliare", 0),
			new Contatto("Reporter", "CHAR_LIFEINVADER", false, "reporter", 0),
		};

		public List<Message> messaggi = new List<Message>();

		public Phone_data() { }

		public Phone_data(dynamic result)
		{
			Theme = (int)result["Theme"].Value;
			Wallpaper = (int)result["WallPaper"].Value;
			if (result["contatti"].HasValues)
				for (int i = 0; i < result["contatti"].Count; i++)
					contatti.Add(new Contatto(result["contatti"]["Name"].Value, result["contatti"]["Icon"].Value, result["contatti"]["TelephoneNumber"].Value, result["contatti"]["IsPlayer"].Value, result["contatti"]["PlayerIndex"].Value, result["contatti"]["Player"].Value));
			if (result["messaggi"].HasValues)
				for (int i = 0; i < result["messaggi"].Count; i++)
					messaggi.Add(new Message(result["messaggi"]["From"].Value, result["messaggi"]["Title"].Value, result["messaggi"]["Messaggio"].Value, (DateTime)result["messaggi"]["Data"].Value));
		}
	}
}
