﻿using CitizenFX.Core;
using static CitizenFX.Core.Native.API;
using System;
using TheLastPlanet.Server.gmPrincipale;
using TheLastPlanet.Server.Telefono.ClientData;
using System.Collections.Generic;
using Newtonsoft.Json;
using System.Threading.Tasks;
using System.Linq;

namespace TheLastPlanet.Shared.Telefono
{
	class TelefonoServer : BaseScript
	{
		public static Dictionary<string, Phone> Phones = new Dictionary<string, Phone>();

		public TelefonoServer()
		{
			EventHandlers.Add("phone_server:receiveMessage", new Action<string, string, string, string, int>(ReceiveMex));
			EventHandlers["lprp:setupUser"] += new Action<Player>(SetupPhone);
			EventHandlers["playerDropped"] += new Action<Player>(Disconnesso);
		}

		public void SetupPhone([FromSource] Player player)
		{
			string handle = player.Handle;
			Exports["ghmattimysql"].execute($"SELECT * FROM `telefoni` WHERE `steam` = '{DB.GetLicense(player, "steam")}'", new Action<dynamic>((result) => 
			{
				string stringa = JsonConvert.SerializeObject(result);
				if (stringa != "[]")
				{
					Phones[handle] = new Phone(player, result[0]);
					string datiphone = JsonConvert.SerializeObject(Phones[handle]);
					TriggerClientEvent(player, "lprp:setupPhoneClientUser", datiphone);
				}
				else
				{
					Exports["ghmattimysql"].execute($"INSERT INTO telefoni (`steam`, `steamName`, `phone_data`) VALUES ('{DB.GetLicense(player, "steam")}', '{GetPlayerName(handle)}', '{"[]"}')", new Action<dynamic>((newResult) =>
					{
						Exports["ghmattimysql"].execute($"SELECT * FROM `users` WHERE `steam` = '{DB.GetLicense(player, "steam")}'", new Action<dynamic>((created) =>
						{
							Phones[handle] = new Phone(player, created[0]);
							string datiphone = JsonConvert.SerializeObject(Phones[handle]);
							TriggerClientEvent(player, "lprp:setupPhoneClientUser", datiphone);
						}));
					}));
				}
			}));
		}

		public async void Disconnesso([FromSource] Player player)
		{
			string name = player.Name;
			if (Phones.ContainsKey(player.Handle))
			{
				var phone = Phones[player.Handle];
				var ped = ServerScript.PlayerList[player.Handle];
				if (ped.status.spawned)
				{
					Exports["ghmattimysql"].execute($"UPDATE `telefoni` SET `steamName` = '{player.Name}', `phone_data` = '{JsonConvert.SerializeObject(phone.phone_data)}' WHERE `steam` = '{ped.identifiers.steam}'", new Action<dynamic>(async result =>
					{
						await Task.FromResult(100);
						phone = null;
					}));
				}
			}
		}

		public async void ReceiveMex(string numero, string nomePers, string nomePlayer, string messaggio, int idPlayer)
		{
			if (numero.All(char.IsDigit))
			{
				for (int i=0; i<= Phones.Count; i++)
				{
					if (Phones.ContainsKey(Convert.ToString(i)))
					{
						if (Phones[Convert.ToString(i)].getCurrentCharPhone().Numero == numero && Convert.ToInt32(numero) != 0)
						{
							Debug.WriteLine(DateTime.Now.ToString("dd/MM/yyyy, HH:mm:ss") + " Il personaggio '" + nomePers + " [" + nomePlayer + "]' ha inviato un messaggio (telefono) a " + ServerScript.PlayerList[Phones[Convert.ToString(i)].p.Handle].getFullName() + "[" + GetPlayerName(Phones[Convert.ToString(i)].p.Handle) + "], con messaggio': \"" + messaggio + "\"");
							TriggerClientEvent(Phones[Convert.ToString(i)].p, "phone:receiveMessage", nomePers, messaggio);
						}
					}
				}
			}
			else
			{
				for (int i = 0; i <= ServerScript.PlayerList.Count; i++)
				{
					if (ServerScript.PlayerList.ContainsKey(Convert.ToString(i)))
					{
						if (ServerScript.PlayerList[Convert.ToString(i)].getCurrentChar().job.name.ToLower() == numero.ToLower())
						{
							TriggerClientEvent(ServerScript.PlayerList[Convert.ToString(i)].p, "phone:receiveMessage", nomePers, messaggio);
							Debug.WriteLine(DateTime.Now.ToString("dd/MM/yyyy, HH:mm:ss") + " Il personaggio '" + nomePers + " [" + nomePlayer + "]' ha inviato un messaggio (telefono) a '" + numero + ": \"" + messaggio + "\"");
						}
					}
				}
			}
		}
	}
}
